#!/bin/bash

opcije='f:d:p:v'

set -- $(getopt $opcije "$@")

while getopts $opcije opt; do
    case $opt in
	f) file=$OPTARG
	   ;;
	d) dir=$OPTARG
	   ;;
	p) pattern=$OPTARG
	   ;;
	v) v='-v'
	   ;;
	*) echo 'Greska Usage: zadatak.sh -f file -d dir -p pattern [-v]'
	   exit -1
	   ;;
    esac
done

if [ -z "$file" -o -z "$dir" -o -z "$pattern" ]; then
    echo 'Greska Usage: zadatak.sh -f file -d dir -p pattern [-v]'
    exit -1
fi

tar -xf "$file"


src_dir=$(echo $file | sed -E "s:.*/([^\.]*).*:\1:")

if [ ! -d $dir ]; then
    mkdir "$dir"
fi

dir=$(realpath $dir)

pushd $src_dir

student='[a-z]{2}[0-9]{6}'

for i in $(find . -maxdepth 1 -name "*" | grep -E $student); do
    name=$(echo $i | sed -E "s:.*($student).*:\1:")
    file_name="$dir/$name.c"

    old_IFS=$IFS
    IFS=$'\n'
    for j in $(find $i  -iname "*.c" | grep -i $v $pattern);do
	cat $j >> $file_name
    done
    IFS=$old_IFS
done
